note
  description: "An example application of the State design pattern"

class MAIN

create make

------------------------------
feature {NONE} -- Creation

make
  -- The entry point of the example.
  local
    m1, m2, m3: MOVIE1
    m4, m5, m6: MOVIE2
    m7, m8, m9: MOVIE3
  do
  -- Design 1: It works but changes are very cumbersome
    create m1.make("Casablanca", "REG")
    create m2.make("Bambi", "CHI")
    create m3.make("The Lord of the Rings", "NEW")
    print("Prices using movie1 design%N")
    print ("  Casablanca for 2 days costs " + m1.price(2).out + "%N")
    print ("  Bambi for 1 day costs " + m2.price(1).out + "%N")
    print ("  Lord of the Rings for 5 days costs " + m3.price(5).out + "%N")

  -- Design2: Takes advantage of polymorphism, but what if
  -- "The Lord of the Rings" is no longer a NEW movie?
    create {REGULAR} m4.make("Casablanca")
    create {CHILDRENS} m5.make("Bambi")
    create {NEW} m6.make("The Lord of the Rings")
    print("%NPrices using movie2 design%N")
    print ("  Casablanca for 2 days costs " + m4.price(2).out + "%N")
    print ("  Bambi for 2 days costs " + m5.price(1).out + "%N")
    print ("  Casablanca for 2 days costs " + m6.price(5).out + "%N")

  -- Design 3: Polymorphism is now delegated to the state object
    create m7.make("Casablanca", "REG")
    create m8.make("Bambi", "CHI")
    create m9.make("The Lord of the Rings", "NEW")
    print("%NPrices using movie3 design%N")
    print ("  Casablanca for 2 days costs " + m7.price(2).out + "%N")
    print ("  Bambi for 2 days costs " + m8.price(1).out + "%N")
    print ("  Lord of the Rings for 2 days costs " + m9.price(5).out + "%N")

    m9.set_type ("REG")
    print("%NThe regular price for a no longer new movie:%N")
    print ("  Lord of the Rings for 2 days costs " + m9.price(5).out + "%N")

  end

end
