note
  description: "Objects that represent movies"
  author: "VT"

class MOVIE1

create make

--------------------------------------------------------------------------------
feature {NONE} -- Creation

make(n,t: STRING)
    -- Create and initialize a movie.
  require
    args_exist: n /= void and t /= void
  do
    name := n.twin
    type := t.twin
  ensure
    name_set: name.is_equal(n)
    type_set: type.is_equal(t)
  end

--------------------------------------------------------------------------------
feature -- Rental

name: STRING
type: STRING

price(days_rented: INTEGER): REAL
    -- What is the charge to rent the currect movie for 'days_rented' days
  require
    positive_days: days_rented >= 0
  do
    if type.is_equal("REG") then
      Result := 2
      if days_rented > 2 then
        Result := Result + ((days_rented - 2) * 1.5).truncated_to_real
      end
    elseif type.is_equal("NEW") then Result := days_rented * 3
    elseif type.is_equal("CHI") then
	    Result := 1.5
	    if days_rented > 3 then
		    Result := Result + ((days_rented - 3) * 1.5).truncated_to_real
	    end
    end

  end

set_type(t: STRING)
  require
    type_exists: t /= void
  do
    type := t.twin
  end

end
