note
  description: "Objects that represent movies (State design pattern)"
  author: "VT"

class MOVIE3

create make

--------------------------------------------------------------------------------
feature {NONE} -- Creation

make(n,t: STRING)
    -- Create and initialize a move.
  require
    args_exist: n /= void and t /= void
  do
    name := n.twin
    set_type(t)
  ensure
    name_set: name.is_equal(n)
    type_set: type /= void
  end

--------------------------------------------------------------------------------
feature -- Movie3

name: STRING
type: MOVIE_STATE

set_type (t: STRING)
  require
    type_exists: t /=void
  do
    if t.is_equal("NEW")     then create {NEW_STATE} type
    elseif t.is_equal("REG") then create {REGULAR_STATE} type
    elseif t.is_equal("CHI") then create {CHILDRENS_STATE} type
    end
  end

price (days_rented: INTEGER): REAL
  -- What is the charge to rent the Currect movie for 'days_rented' days
  require
    positive_days: days_rented > 0
  do
    Result := type.price(days_rented)
  end

invariant
  state_always_exists: type /= Void

end
